#*************************************************************
# Progamm:			graphik_vergleich
# Sinn des Programms: 		Graphische Darstellung und Vergleich von zwei Funktionen
# Sinn der Einheit  :		Einlesen der Steuerdaten aus der Steuerdatei	
# Name dieser Datei:		steuer.py
# Versionsnummer:		2
# Wird aufgerufen von:		graphik_vergleich_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	2
# von:				4			
# Autor: 			Armin Ulrich
# Erster Lauf: 			10.02.2024
# Letzte Änderung: 		04.03.2024
#*************************************************************

#*************************************************************
# Importieren der Klassen für Dateiauslesung
#*************************************************************
import os

#*************************************************************
# Importieren der Klassen zur graphischen Darstellung 
#*************************************************************
import tkinter


main = tkinter.Tk()

class Steuer:
  #Konstruktormethode
  def __init__(self):		
    print("Steuerobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Steuerobjekt entfernt")  

  def ende(self):
    main.destroy()


#*************************************************************
# Funktion zum Öffnen der Steuerdatei und zum Auslesen der
# Steuerdaten
#*************************************************************
  def steuer_input(self):
    print("Einlesen der Steuerdaten") 
    zeilen_zähler=0

    self.rückgabeliste = list(range(2))
    self.rückgabeliste[0] = True                                   			# Einlesen von Steuerdatei korrekt            True/False
    self.rückgabeliste[1] = "Steuerdatei wurde korrekt gelesen."    			# Fehlermeldung für Einlesen aus Steuerdatei  Text

#*************************************************************
# Überprüfung ob die Steuerdatei existiert 
#*************************************************************
    if os.path.exists("steuer.txt"):
      print("Steuerdatei ist vorhanden")

#*************************************************************
# Öffnen der Steuerdatei
#*************************************************************
      with open("steuer.txt", "r") as fobj_in:

#*************************************************************
# Einlesen der Steuerdaten zeilenweise
#*************************************************************
        for zeile in fobj_in:
       
          if(zeilen_zähler == 0):
            länge = len(zeile) 
            ausgabe = zeile[:-1]
            print(ausgabe)
          if(zeilen_zähler == 1):
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
            länge = len(zeile)
            self.temperatur_datei = zeile[:-1]
            ausgabe = self.temperatur_datei
            print(ausgabe)
          if(zeilen_zähler == 2):
            länge = len(zeile) 
            ausgabe = zeile[:-1]
            print(ausgabe)
          if(zeilen_zähler == 3):
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
            länge = len(zeile)
            self.meeresspiegel_datei = zeile[:-1]
            ausgabe = self.meeresspiegel_datei
            print(ausgabe)
          if(zeilen_zähler == 4):
            länge = len(zeile) 
            ausgabe = zeile[:-1]
            print(ausgabe)
          if(zeilen_zähler == 5):
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
            länge = len(zeile)
            self.schirm_ausgabe_wähler = bool(int(zeile))
            ausgabe = str(self.schirm_ausgabe_wähler)
            print(ausgabe)
          if(zeilen_zähler == 6):
            länge = len(zeile) 
            ausgabe = zeile[:-1]
            print(ausgabe)
          if(zeilen_zähler == 7):
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
            länge = len(zeile)
            self.datei_ausgabe_wähler = bool(int(zeile))
            ausgabe = str(self.datei_ausgabe_wähler)
            print(ausgabe)
          if(zeilen_zähler == 8):
            länge = len(zeile) 
            ausgabe = zeile[:-1]
            print(ausgabe)
          if(zeilen_zähler == 9):
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
            länge = len(zeile)
            self.graphik_ausgabe_wähler = bool(int(zeile))
            ausgabe = str(self.graphik_ausgabe_wähler)
            print(ausgabe)
          if(zeilen_zähler == 10):
            länge = len(zeile) 
            ausgabe = zeile[:-1]
            print(ausgabe)
          if(zeilen_zähler == 11):
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
            länge = len(zeile)
            self.graphik_datei_ausgabe_wähler = bool(int(zeile))
            ausgabe = str(self.graphik_datei_ausgabe_wähler)
            print(ausgabe)          
          if(zeilen_zähler == 12):
            länge = len(zeile) 
            ausgabe = zeile[:-1]
            print(ausgabe)
          if(zeilen_zähler == 13):
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
            länge = len(zeile)
            self.ausgabe_datei_1 = zeile[:-1]
            ausgabe = self.ausgabe_datei_1 
            print(ausgabe)
          if(zeilen_zähler == 14):
            länge = len(zeile) 
            ausgabe = zeile[:-1]
            print(ausgabe)
          if(zeilen_zähler == 15):
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
            länge = len(zeile)
            self.graphik_datei_1 = zeile[:-1]
            ausgabe = self.graphik_datei_1 
          if(zeilen_zähler == 16):
            länge = len(zeile) 
            ausgabe = zeile[:-1]
            print(ausgabe)  
          
          self.graphik_formate_zulässig = set(['eps', 'pdf', 'pgf','png', 'ps', 'raw', 'rgba', 'svg',  'svgz'])           

          if(zeilen_zähler == 17):
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
            länge = len(zeile)
            self.graphik_format_1 = zeile[:-1]
            ausgabe = self.graphik_format_1 
          
            if self.graphik_format_1 in self.graphik_formate_zulässig:
              pass
            else:
              self.rückgabeliste[0] = False 
              self.rückgabeliste[1] = "Fehler in Steuerdatei: Python unterstützt das Graphikformat nicht!\nProgramm bricht ab!" 
          
          if(zeilen_zähler == 18):
            länge = len(zeile) 
            ausgabe = zeile[:-1]
            print(ausgabe)
          if(zeilen_zähler == 19):
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
            länge = len(zeile)
            self.graphik_titel_1 = zeile[:-1]
            ausgabe = self.graphik_titel_1 
          if(zeilen_zähler == 20):
            länge = len(zeile) 
            ausgabe = zeile[:-1]
            print(ausgabe)
          if(zeilen_zähler == 21):
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
            länge = len(zeile)
            self.graphik_ordinate_1 = zeile[:-1]
            ausgabe = self.graphik_ordinate_1 
            print(ausgabe)
          if(zeilen_zähler == 22):
            länge = len(zeile) 
            ausgabe = zeile[:-1]
            print(ausgabe)
          if(zeilen_zähler == 23):
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
            länge = len(zeile)
            self.ausgabe_datei_2 = zeile[:-1]
            ausgabe = self.ausgabe_datei_2 
            print(ausgabe)
          if(zeilen_zähler == 24):
            länge = len(zeile) 
            ausgabe = zeile[:-1]
            print(ausgabe)

          if(zeilen_zähler == 25):
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
            länge = len(zeile)
            self.graphik_datei_2 = zeile[:-1]
            ausgabe = self.graphik_datei_2 
            print(ausgabe)
          if(zeilen_zähler == 26):
            länge = len(zeile) 
            ausgabe = zeile[:-1]
            print(ausgabe)
          if(zeilen_zähler == 27):
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
            länge = len(zeile)
            self.graphik_format_2 = zeile[:-1]
            ausgabe = self.graphik_format_2 
            print(ausgabe)       
            if self.graphik_format_2 in self.graphik_formate_zulässig:
              pass
            else:
              self.rückgabeliste[0] = False 
              self.rückgabeliste[1] = "Fehler in Steuerdatei: Python unterstützt das Graphikformat nicht!\nProgramm bricht ab!"               
          if(zeilen_zähler == 28):
            länge = len(zeile) 
            ausgabe = zeile[:-1]
            print(ausgabe)          
          if(zeilen_zähler == 29):
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
            länge = len(zeile)
            self.graphik_titel_2 = zeile[:-1]
            ausgabe = self.graphik_titel_2 
          if(zeilen_zähler == 30):
            länge = len(zeile) 
            ausgabe = zeile[:-1]
            print(ausgabe)
          if(zeilen_zähler == 31):
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
            länge = len(zeile)
            self.graphik_ordinate_2 = zeile[:-1]
            ausgabe = self.graphik_ordinate_2 
#*************************************************************
# Anzeigen der Steuerdaten mittels Label
#*************************************************************        
          lb = tkinter.Label(main, text = ausgabe)
        
          if zeilen_zähler % 2 == 0:
            lb.grid(row=int(zeilen_zähler/2), column=0, padx='1', pady='1', sticky='ew')
          #lb["font"] = "Arial 6 bold"
          else:
            lb.grid(row=int((zeilen_zähler-1)/2), column=1, padx='1', pady='1', sticky='ew')
          lb["font"] = "Arial 10"
        #lb["height"] = 1
        #lb["width"] = 40
        #lb["borderwidth"] = 2
        #lb["relief"] = "ridge"
          lb["bg"] = "#FFFFFF"
          lb["fg"] = "#000000"
          if zeilen_zähler % 2 == 0:
            lb["anchor"] = "w"
          else:
            lb["anchor"] = "e"
        #lb.pack() 
          zeilen_zähler=zeilen_zähler+1

#*************************************************************
# Button zum Beenden der Anzeige der Steuerdaten und 
# zum Start der Berechnungen
#*************************************************************
      b = tkinter.Button(main, text = "weiter", command = self.ende)
      b.grid(row=int(zeilen_zähler/2), column=0, padx='1', pady='1', sticky='ew')
      
      
      #Endlosschleife
      main.mainloop()
      
      return True
    else:
      print("Steuerdatei ist NICHT vorhanden")
      return False
